function SEcalcSi(varargin)  % version  11-Martch-2002
% Corrected bugs
% Calculation tube(triode, pentode) stage  in Class A.
% Added spectrum analysis.
% Added write/read option for test signal
% Copyright (C) 2001 by Eugene V. Karpov. The author assumes no legal 
% liability arising from the use of this program.
% E-mail ekar@next-power.net

global MU EX KG1 KP KVB VCT a b Ug Type fname Pfn Us 

Type='';
MU=[]; EX=[]; KG1=[]; KP=[]; KVB=[]; Us=[]; 
Ipmax=[]; Ppmax=[]; Upmax=[]; Ugmax=[]; 
Ugstep=-1;									%Default Ug step
VCT=0;										%Default value
Pfn=1;										%Default value for pentode
N=1024;										%Default N-point for Fourier transform
												%Upstep=1V is const.

%Load data file
%%%%%%%%%%%%%%%%%%%%%%%% Format data file  %%%%%%%%%%%%%%%%%%%%%%%%%%%
%File name  ---> 6N8C.mod
%Name='6N8C'; Type='Triode'; or Pentode
% Model data:
%MU=22.87;  EX=1.516;  KG1=2209.8;  KP=167.87; KVB=155.4;  VCT=0.70; 
% Analysis data: 
%Ipmax=.02; Ppmax=2.7; Upmax=300; Ugmax=-10; Ugstep=-0.5;
%for pentode add following parameters:
%KG2=  ;  Us=   ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[fname,pname] = uigetfile('*.mod');	%Selection data file
if isempty(findstr(fname,'.mod'))
   error('File not selected');
end
fid=fopen(fname,'rt');					%Open data file
if fid<0
   error('Do not reading');
end
while 1  line = fgetl(fid);			%Load data file 
   if ~isstr(line)
      break 
   end
   eval(line,'fprintf(''%s%s\n'',12,lasterr);');
end; 
fclose(fid);
%Check data
errmes1='Shortage data, absence'; errmes2=' Check up data file.';
if isempty(MU); error([errmes1,' MU.',errmes2]); end
if isempty(KVB); error([errmes1,' KVB.',errmes2]); end
if isempty(EX); error([errmes1,' EX.',errmes2]); end
if isempty(KG1); error([errmes1,' KG1.',errmes2]); end
if isempty(KP); error([errmes1,' KP.',errmes2]); end
if isempty(Upmax); error([errmes1,' Upmax.',errmes2]); end
if isempty(Ipmax); error([errmes1,' Ipmax.',errmes2]); end
if isempty(Ugmax); error([errmes1,' Ugmax.',errmes2]); end
if isempty(Ppmax); error([errmes1,' Ppmax.',errmes2]); end

%Check tube type
switch Type;
     case 'Pentode',...
     if isempty(Us); error([errmes1,' Us.',errmes2]); end,...		%Check data
     if isempty(KG2); error([errmes1,' UG2.',errmes2]); end,...	%Check data
     case 'Triode',
  otherwise
     clear
         error('Absence tube Type')
end

h = waitbar(0,'Please wait...');
%Setting
nstep=ceil(Ugmax./Ugstep);		%Step for Ug
cm=['k','b','g','r','m'];		%COLOR MAP	
cp=1;									%Color pointer
dat2=[''];
%Calculation Ri 
a=Upmax; b=Ipmax;					%Test load line
for g1=0:1:nstep
   Ug=g1.*Ugstep;
   x=fminsearch('se',[20],[]);
   sUp(g1+1)=x;
   Up=x;
   il1(g1+1)=inst(Up,Ug);		%Test plate carrent
end
sUp=sUp+1;							%Delta Up=1V
for g1=0:1:nstep
   Ug=g1.*Ugstep;
   Up=sUp(g1+1);
   il2(g1+1)=inst(Up,Ug);		%Delta I plate
   waitbar(g1+1./nstep)
end
ri=1./(il2-il1);
Ri=mean(ri);						%Ohm
close(h);
%Calculation S
sUp=sUp-1;
for g1=0:1:nstep
   Ug=g1.*Ugstep+Ugstep./5;
   Up=sUp(g1+1);
   il3(g1+1)=inst(Up,Ug);		%Delta I plate
end
s=(il3-il1)./(Ugstep./5);
S=mean(s);
%Plot Ri, S data
figure(1);
subplot(2,1,1); plot(il1,ri); grid on;axis tight; title([Name,' Output resistance']);...
xlabel('Ip'); ylabel('Ri');
subplot(2,1,2); plot(il1,s); grid on; axis tight; title([Name,' Transconductance']);...
xlabel('Ip'); ylabel('S');
zoom on;
set(1,'Pointer','circle');
h = msgbox('             CONTINUE');
 set(h,'position',[10 50 124.759 54]);
 waitfor(h);
 zoom off;

%Calculation plate carrent

h = waitbar(0,'Please wait...');

for g1=0:1:nstep;
   Ug=g1.*Ugstep;
   for p=1:1:Upmax
       Up=p;
       I(g1+1,p)=inst(Up,Ug);
    end
    waitbar(g1./nstep);
end
close(h);

%Calculation max plate carrent
Upplot=1:1:Upmax; 
Imaxplot=Ppmax./Upplot;
%Plot PLATE CHARACTERISTICS
clf reset;
plot(Upplot,I,'b'); grid on; axis([0 Upmax 0 Ipmax]); xlabel('Up'); ylabel('Ip');...
title([Name,' PLATE CHARACTERISTICS']);
hold on 
plot(Imaxplot,'r.');
set(1,'Pointer','fullcrosshair');

while 1;
   if cp==5;									%set color plot
      cp=0;
   end
   cp=cp+1;
c1=1;

%Entry load line
while c1==1;
select=menu('Entry load line','Draw load line by Rl and Usup',...
   'Draw load line by two point');    %Select next step
if isempty(select);
   	close all;
   	clear
    	error('Break-down Calculation')
    elseif select==1;
       while 1
  		 	 def={sprintf('%6.1f',Ri),sprintf('%3.1f',Upmax)};
          lines=1;
          prompt={'R load Ohm','U supply V'}; titlle='Enter data';...
       	 select=inputdlg(prompt,titlle,lines,def);
          if  isempty(select);
          else;  break;
       	 end
        end
        if isempty(select{1});					%Check data
           select{1}=sprintf('%6.1f',Ri);		   
        end
        if isempty(select{2});					%Check data
           select{2}=sprintf('%3.1f',Upmax);
        end
        
    Rl=eval(select{1}); Usup=eval(select{2});  %Calculation load line by Rl and Usup
    il=(-1./Rl).*Upplot+Usup./Rl;
	 a=Usup; b=Usup./Rl;
    plot(il,cm(cp))									%Plot load line
 else select==2;										%Calculation load line by two point
    x=[]; y=[];
    while isempty(x)
       [x,y]=ginput(1);       						%first point
    end   
    p=length(x); g1=length(y);
    Ip1=y(g1); Up1=x(p);
    plot(Up1,Ip1,'rx','MarkerSize',15);
    
    x=[]; y=[];
    while isempty(x)
       	[x,y]=ginput(1);       						%Second point
    end
    p=length(x); g1=length(y);
    Ip2=y(g1); Up2=x(p);
    if Ip2>=Ip1;				  						%Check Ip2 value --> Ip2>Ip1
       Ip2=Ip1.*.99;
    end
    plot(Up2,Ip2,'rx','MarkerSize',15);
    il=(((Up1-Upplot).*(Ip2-Ip1))./(Up1-Up2))+Ip1;
    a=(-(Up1.*Ip2-Up2.*Ip1))./(Ip1-Ip2);
	 b=((Up1.*(Ip2-Ip1))./(Up1-Up2))+Ip1;
    Rl=a./il(1);
    plot(il,cm(cp))									 %Plot load line	
 end
  select=menu('Your choice','New R load',...  %Select next step
  'CONTINUE');
if isempty(select);
   close all;
   clear
   error('Break-down Calculation')
elseif select==2;
       c1=2;
    end
end

 %Draw Load line - il1=f(Ug)
    h = waitbar(0,'Please wait...');
for g1=0:1:nstep*10;
   Ug=g1.*Ugstep/10;    
   sUg(g1+1)=Ug;   			   				%Step Ug
   x=fminsearch('se',[20],[]);
   Up=x;
   il1(g1+1)=inst(Up,Ug); 						%Plate carrent
   waitbar(g1./nstep./10);
end
close(h);
figure(2);
plot(sUg,il1,cm(cp)); grid on; xlabel('Ug'); ylabel('Ip');...
   title([Name,' GRID-PLATE CHARACTERISTICS']);
%zoom on

while c1==2;
%Calculation stage parameters
x=[]; y=[];
while isempty(x);										% Input Ug0 (quiescent state)
   [x,y]=ginput(1);
end

p=length(x); g1=length(y);
Ug0=x(p);
Ug1=0; Ug2=Ug0./2; Ug3=Ug0+Ug2; Ug4=Ug0.*2;	 %Grid step

Ug=Ug0; x=fminsearch('se',[20],[]); Up0=x; Up=x; I0=inst(Up,Ug);
hold on
plot(Ug0,I0,'rx','MarkerSize',15);
Ug=Ug1; x=fminsearch('se',[20],[]); Up1=x; Up=x; I1=inst(Up,Ug); 
Ug=Ug2; x=fminsearch('se',[20],[]); Up2=x; Up=x; I2=inst(Up,Ug); 
Ug=Ug3; x=fminsearch('se',[20],[]); Up3=x; Up=x; I3=inst(Up,Ug);
Ug=Ug4; x=fminsearch('se',[20],[]); Up4=x; Up=x; I4=inst(Up,Ug);
HD1=(I1-I4+I2-I3)./3;									  %First Harmonic
HD2=(I1+I4-2.*I0)./4;                             %Second Harmonic Distortion
HD3=(I1-I4-2.*(I2-I3))./6;                        %Third Harmonic Distortion
HD4=(I1+I4-4.*(I2+I3)+6.*I0)./12;					  %Fourth Harmonic Distortion
HD=sqrt(HD2^2+HD3^2+HD4^2)./HD1.*100;				  %THD
HD2=HD2./HD1.*100;
HD3=HD3./HD1.*100;
HD4=HD4./HD1.*100;
dUp=Up4-Up1;												  %Output voltage
P=(dUp^2)./(8.*Rl);										  %Outpout power
Kg=dUp./Ug4;												  %Gain

%Print data
if isempty(dat2)
	disp(sprintf('\n'));
	disp(['Tube  ',Name,'     ',date]);
else
   disp('New set');
end
disp(['HD=',sprintf('%2.2f',HD),'%','   HD2=',sprintf('%2.2f',HD2),'%',...
'  HD3=',sprintf('%2.2f',HD3),'%','  HD4=',sprintf('%2.3f',HD4),'%']);
disp(['Pout=',sprintf('%2.2f',P),'W','  Uout=',sprintf('%3.1f',dUp),'V','  G=',...
sprintf('%3.1f',Kg),'  Rload=',sprintf('%6.1f',Rl),'Ohm']);
disp(['Ug0=',sprintf('%2.2f',Ug0),'V','  I0=',sprintf('%3.4f',I0),'A']);
dat1=['HD=',sprintf('%2.2f',HD),'%','  HD2=',sprintf('%2.2f',HD2),'%',...
      '  HD3=',sprintf('%2.2f',HD3),'%','  HD4=',sprintf('%2.3f',HD4),'%',...
      '     Pout=',sprintf('%2.2f',P),'W','  Uout=',sprintf('%3.1f',dUp),'V',...
      '  Rl=',sprintf('%6.1f',Rl./1000),'KOhm'];
h=outData(dat1,dat2);
dat2=dat1;

%Select next step
c1=5;
while c1==5;
   F_W=1;											%Enable write
	select=menu('Spectrum','           Yes          ','No'); 
if isempty(select);
    close all
  clear
  error('Break-down Calculation')
   elseif select==1;
      %Calculation spectrum
      %Load max magnitude Ug
	prompt={'V'}; titlle='Input grid magnitude';
	def={sprintf('%3.1f',abs(Ug0))};
	lines=1;
   select=inputdlg(prompt,titlle,lines,def);
   if isempty(select); break; end;
   if isempty(select{1}); break; end;
   
   UgmaxS=abs(eval(select{1}));					%Magnitude test signal
	if UgmaxS>abs(Ug0);
   	UgmaxS=abs(Ug0);
	end
   %Select iput sourse
   select=menu('Input source','         File        ','Test'); 
   if select==1;
      [fname,pname] = uigetfile('*.bin');		%Selection binary file
      if isempty(findstr(fname,'.bin')); break; end;
      fid=fopen(fname,'r');						%Open binary file
      if fid<0
         h = msgbox('         Do not reading');
 			set(h,'position',[10 50 124.759 54]);
         waitfor(h);
			break
      end
      [UgS,count]=fread(fid,'float32');		%Read binary file
      fclose(fid);
      N=count;
      rot90(UgS);
      %Scaling
      scale=UgmaxS./max(UgS);
      if scale<1;
         UgS=UgS.*scale;
      end
      UgS=UgS.*-1;
      UgmaxS=max(UgS);
      F_W=0;											%Inhibit write
   else
		t=0:1*10^-3/(N-1):10^-3;					%Generation test signal f=1kHz
		UgS=UgmaxS.*sin([2.*pi.*1000*t]);
	end
   	UgS=UgS+Ug0;									%Grid input signal
	%Calculation output voltage
	hs = waitbar(0,'Please wait...');
	for g1=1:1:N
   	Ug=UgS(g1);
   	x=fminsearch('se',[20],[]);
   	Up=x;
   	IS(g1)=inst(Up,Ug);
   	waitbar(g1./N);
	end
   US=IS.*Rl;
  	dUp=max(US)-min(US);							%Output voltage
	P=(dUp^2)./(8.*Rl);							%Output power
	close(hs)
	%Fourier transform
	Y=fft(US,N);								
   SS=abs(Y)./(N./2);							%Harmonics magnitude
   US0=SS(1)./2;									%Save Steady component
  	SS(1)=0;											%Delete steady component
	D=SS(3:12).^2;									%Total Harmonic Distortion
	D=sqrt(sum(D))./SS(2).*100;				
	SS=SS(1:13)./SS(2).*100;					%Normalization
	SS(2)=0;											%Delete first harmonic
	f=1000*(0:12);									%Plot data
	figure(4);
	stem(f,SS,'filled'); grid on;	xlabel('kHz'); ylabel('%');...
      title([Name,' Spectrum output voltage. Magnitude Ug=',sprintf('%3.1f',UgmaxS)]);
   zoom on;
   set(4,'Pointer','circle');
   %Print result
   disp('Calculation spectrum:');
	disp(['Magnitude Ug=',sprintf('%3.1f',UgmaxS),'V']);
	disp(['Pout=',sprintf('%2.2f',P),'W','  Uout=',sprintf('%3.1f',dUp),'V peak-to-peak']);
	disp(['HD=',sprintf('%2.2f',D),'%','  HD2=',sprintf('%2.2f',SS(3)),'%',...
      		'  HD3=',sprintf('%2.2f',SS(4)),'%','  HD4=',sprintf('%2.3f',SS(5)),'%',...
            '  HD5=',sprintf('%2.3f',SS(6)),'%']);
   dat1=['HD=',sprintf('%2.2f',D),'%','  HD2=',sprintf('%2.2f',SS(3)),'%',...
      		'  HD3=',sprintf('%2.2f',SS(4)),'%','  HD4=',sprintf('%2.3f',SS(5)),'%',...
            '  HD5=',sprintf('%2.3f',SS(6)),'%','    Pout=',sprintf('%2.2f',P),'W',...
            '  Uout=',sprintf('%3.1f',dUp),'V'];
      close(h);  h=outData(dat1,dat2); dat2=dat1;
      %Write output signal in binary file
    if F_W==1;
      fname=strcat(Name,'.bin');     
      fid=fopen(fname,'w');
      US=US-US0;								%Delete steady component
      count=fwrite(fid,US,'float32');
      fclose(fid);
      %Check write
      if count~=N;
         h = msgbox('          DO NOT SAVE');
 			set(h,'position',[10 50 124.759 54]);
          waitfor(h);
       end
    else
       disp(['Input data  ',fname]);	%Print binary file name
    end
    F_W=1;										%Enable write
   else
      c1=10;
 end  
end
close(figure(4)); zoom off;
 
%Select next step
select=menu('Your choice','New Ug',...  
   'New R load','Quit');
if  select==1; 
   c1=2;
   figure(2);
   close(h);
elseif select==2;
   c1=3;
   figure(1);
   close(h);
  else 
   close all
   clear
  return
end
end
end












   
   




   


